unit Helper3deliteForms;

interface

Uses
    Windows,
    SysUtils,
    UITypes,
    Controls,
    Forms,
    ComCtrls,
    Dialogs;

    function RepositionWindowIfNotVisible(Window: TForm): Boolean;
    procedure SetAsMainForm(aForm: TForm);
    procedure SetAsMainForm2(aForm:TForm);
    function CreatePath(Path: String): Boolean;
    procedure WordWrapHints(Control: TWinControl);
    procedure ReSetHeightConstraints(Control: TWinControl);
    procedure SetToolBarsAutoSizedNotTransparent(Control: TWinControl; BckgColor: TColor);

implementation

function RepositionWindowIfNotVisible(Window: TForm): Boolean;
var
  DC: HDC;
begin
    //Result := False;
    DC := GetDC(Window.Handle);
    try
        if NOT RectVisible(DC, Window.ClientRect) then begin
            Window.MakeFullyVisible;
        end;
    finally
        ReleaseDC(Window.Handle, DC);
    end;
    Result := True;
end;

procedure SetAsMainForm(aForm: TForm);
var
    P:Pointer;
begin
    P := @Application.Mainform;
    Pointer(P^) := aForm;
end;

procedure SetAsMainForm2(aForm:TForm);
var
  P:Pointer;
begin
  Application.MainFormOnTaskBar := False;
  try
    P := @Application.Mainform;
    Pointer(P^) := aForm;
    aForm.Show;
  finally
    Application.MainFormOnTaskBar := True;
  end;
end;

function CreatePath(Path: String): Boolean;
var
  Success: Boolean;
begin
    Success := False;
    repeat
        if NOT ForceDirectories(IncludeTrailingPathDelimiter(Path)) then begin
            Result := False;
            if MessageDlg('Error: Creating path: ' + (#13#10)
                + IncludeTrailingPathDelimiter(Path)
                , mtError, [mbOK, mbRetry], 0) = mrOK
                then Success := True;
        end else begin
            Success := True;
            Result := True;
        end;
    until Success;
end;

procedure WordWrapHints(Control: TWinControl);
var
  i: Integer;
  HintStr: String;
begin
    for i := 0 to Control.ControlCount - 1 do begin
        try
            HintStr := '';
            HintStr := (Control.Controls[i] as TControl).Hint;
            if HintStr <> '' then begin
                HintStr := StringReplace(HintStr, ' /n/n ', #13#10, [rfReplaceAll]);
                (Control.Controls[i] as TControl).Hint := HintStr;
            end;
            try
                if Control.Controls[i] is TWinControl then begin
                    if (Control.Controls[i] as TWinControl).ControlCount > 0
                        then WordwrapHints(TWinControl(Control.Controls[i]));
                end;
            except
                //*
            end;
        except
            //*
        end;
    end;
end;

procedure ReSetHeightConstraints(Control: TWinControl);
var
  i: Integer;
  //HintStr: String;
begin
    for i := 0 to Control.ControlCount - 1 do begin
        try
            if Control.Controls[i] is TWinControl then begin
                (Control.Controls[i] as TWinControl).Constraints.MinHeight := 0;
            end;
            try
                if Control.Controls[i] is TWinControl then begin
                    if (Control.Controls[i] as TWinControl).ControlCount > 0
                        then ReSetHeightConstraints(TWinControl(Control.Controls[i]));
                end;
            except
                //*
            end;
        except
            //*
        end;
    end;
end;

procedure SetToolBarsAutoSizedNotTransparent(Control: TWinControl; BckgColor: TColor);
var
    i: Integer;
    ToolBar: TToolBar;
begin
    for i := 0 to Control.ControlCount - 1 do begin
        if Control.Controls[i] is TToolBar then begin
            ToolBar := (Control.Controls[i] as TToolBar);
            //if StyleServices.Enabled
            //AND (TStyleManager.ActiveStyle.Name <> 'Windows')
            //then begin
            //    (Control.Controls[i] as TToolBar).DrawingStyle := dsGradient;
            //end;

            ToolBar.ParentColor := False;
            ToolBar.GradientDrawingOptions := ToolBar.GradientDrawingOptions - [gdoGradient];
            ToolBar.Wrapable := False;
            ToolBar.AutoSize := True;
            //ToolBar.Transparent := False;
            ToolBar.Color := BckgColor;

        end else begin
            if Control.Controls[i] is TWinControl then begin
                if (Control.Controls[i] as TWinControl).ControlCount > 0
                    then SetToolBarsAutoSizedNotTransparent(TWinControl(Control.Controls[i]), BckgColor);
            end;
        end;
    end;
end;

end.

