//********************************************************************************************************************************
//*                                                                                                                              *
//*     TRegistration 2.1.24.299  3delite 2006-2024                                                                             *
//*     See TRegistration ReadMe.txt for details                                                                                 *
//*                                                                                                                              *
//* Two licenses are available if you like this component:                                                                       *
//* Shareware license: 125                                                                                                      *
//*     http://www.shareit.com/product.html?productid=300091298                                                                  *
//* Commercial license: 250                                                                                                     *
//*     http://www.shareit.com/product.html?productid=300091297                                                                  *
//*                                                                                                                              *
//*     https://www.3delite.hu/Object Pascal Developer Resources/tregistration.html                                              *
//*                                                                                                                              *
//* If you have any of the aforementioned please email: 3delite@3delite.hu                                                       *
//*                                                                                                                              *
//* Good coding! :)                                                                                                              *
//* 3delite                                                                                                                      *
//********************************************************************************************************************************

unit RegForm;

interface

uses
  Windows, Messages, SysUtils, Variants, UITypes, Classes, Vcl.Graphics, Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls, ShellApi, Vcl.ExtCtrls, Inifiles,
  CalcReg, Helper3delite, Helper3deliteWin;

type
  TFormReg = class(TForm)
    GroupBoxContainer: TGroupBox;
    EditRegNum: TEdit;
    EditEmail: TEdit;
    EditName: TEdit;
    ButtonClose: TButton;
    GroupBoxRegister: TGroupBox;
    LabelRegNum: TLabel;
    LabelName: TLabel;
    LabelEMail: TLabel;
    LabelText1: TLabel;
    ImageReg: TImage;
    EditVerCode: TEdit;
    Label1: TLabel;
    LabelText2: TLabel;
    LabelOrder: TLabel;
    ButtonRequest: TButton;
    ButtonOK: TButton;
    MemoStrings: TMemo;
    procedure FormCreate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ButtonCloseClick(Sender: TObject);
    procedure ButtonRequestClick(Sender: TObject);
    procedure ButtonRegisterClick(Sender: TObject);
    procedure LabelOrderClick(Sender: TObject);
    procedure LabelOrderMouseEnter(Sender: TObject);
    procedure LabelOrderMouseLeave(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormDeactivate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure EditNameChange(Sender: TObject);
    procedure ButtonOKClick(Sender: TObject);
    procedure EditNameExit(Sender: TObject);
    procedure EditEmailExit(Sender: TObject);
    procedure EditVerCodeExit(Sender: TObject);
    procedure EditRegNumExit(Sender: TObject);
  private
    { Private declarations }
    rAOwner: TComponent;
  public
    { Public declarations }
    STR_REG_TEXT1: String;
    STR_REG_TEXT2: String;
    STR_REG_ORDER: String;
    STR_GROUPBOX_CAPTION: String;
    STR_REG_NOTENINFO1: String;
    STR_REG_NOTENINFO2: String;
    STR_REQUESTCODE1: String;
    STR_REQUESTCODE2: String;
    STR_THANKYOU1: String;
    STR_THANKYOU2: String;
    STR_THANKYOU3: String;
    STR_ERROR_REG1: String;
    STR_ERROR_REG2: String;
    STR_ERROR_VERCODE1: String;
    STR_ERROR_VERCODE2: String;
    DoNotCloseRegistrationWindow: Boolean;
    Constructor Create(AOwner: TComponent); override;
    Destructor Destroy; override;
    procedure SetNewRegData;
    procedure RequestNewVersionCode;
  end;

implementation

uses
    ClipBrd,
    RegistrationDefs;

{$R *.dfm}

Constructor TFormReg.Create(AOwner: TComponent);
begin
    rAOwner := AOwner;
    inherited Create(AOwner);
end;

Destructor TFormReg.Destroy;
begin
    rAOwner := nil;
    inherited Destroy;
end;

procedure TFormReg.FormCreate(Sender: TObject);
begin
    if Assigned(TRegistration(rAOwner).OnRegistrationDialogCreate) then begin
        TRegistration(rAOwner).OnRegistrationDialogCreate(rAOwner, Self);
    end;
    Icon.Handle := ImageReg.Picture.Icon.Handle;
    //* Extract the current language strings
    STR_REG_TEXT1 := LabelText1.Caption;
    STR_REG_TEXT2 := LabelText2.Caption;
    STR_REG_ORDER := LabelOrder.Caption;
    STR_GROUPBOX_CAPTION := GroupBoxContainer.Caption;

    STR_REG_NOTENINFO1 := MemoStrings.Lines[0];
    STR_REG_NOTENINFO2 := MemoStrings.Lines[1];
    STR_REQUESTCODE1 := MemoStrings.Lines[2];
    STR_REQUESTCODE2 := MemoStrings.Lines[3];
    STR_THANKYOU1 := MemoStrings.Lines[4];
    STR_THANKYOU2 := MemoStrings.Lines[5];
    STR_THANKYOU3 := MemoStrings.Lines[6];
    STR_ERROR_REG1 := MemoStrings.Lines[7];
    STR_ERROR_REG2 := MemoStrings.Lines[8];
    STR_ERROR_VERCODE1 := MemoStrings.Lines[9];
    STR_ERROR_VERCODE2 := MemoStrings.Lines[10];
end;

procedure TFormReg.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    //*
end;

procedure TFormReg.ButtonCloseClick(Sender: TObject);
begin
    Close;
end;

procedure TFormReg.ButtonRequestClick(Sender: TObject);
begin
    SetNewRegData;
    RequestNewVersionCode;
end;

procedure TFormReg.RequestNewVersionCode;
var
    Email: String;
    StrBody: String;
begin
    try

        if IntToStr(CalcRegNum(TRegistration(rAOwner).RegName, TRegistration(rAOwner).RegEmail, TRegistration(rAOwner).RandomSeedReg)) <> Copy(TRegistration(rAOwner).RegNumber, 7, 6) then begin
            if Assigned(TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode)
                then TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode(rAOwner, TRegistration(rAOwner).RegName, TRegistration(rAOwner).RegEmail, TRegistration(rAOwner).RegNumber)
                else MessageDlg(STR_REG_NOTENINFO1 + (#13#10)
                    + STR_REG_NOTENINFO2, mtWarning, [mbOk], 0);
            Exit;
        end;

        (*
        if Assigned(TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode)
            then TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode(Sender, EditName.Text, EditEmail.Text, EditRegNum.Text)
            else if MessageDlg(STR_REQUESTCODE1 + (#13#10)
                + STR_REQUESTCODE2
                , mtConfirmation, [mbYes, mbCancel], 0) = mrYes
                then begin
                    StrBody := 'Name: ' + EditName.Text + (#13#10)
                        + 'E-mail: ' + EditEmail.Text + (#13#10)
                        + 'Registration Number: ' + Copy(EditRegNum.Text, 1, 6) + (#13#10)
                        + TRegistration(rAOwner).TextAppName + ' ' + GetFileVersionStr(Application.ExeName) + (#13#10);
                    Email := 'mailto:' + TRegistration(rAOwner).VerCodeUpdateEmailAddress + '?subject=' + TRegistration(rAOwner).TextAppName + ' - Request Version Code' + '&body=' + StrBody;
                    ShellExecute(Handle,'open', PChar(Email), nil, nil, SW_SHOWNORMAL);
                end;
            *)

        if Assigned(TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode)
            then TRegistration(rAOwner).OnNotEnoughInfoForReqVerCode(rAOwner, TRegistration(rAOwner).RegName, TRegistration(rAOwner).RegEmail, TRegistration(rAOwner).RegNumber)
            else if MessageDlg(STR_REQUESTCODE1 + (#13#10)
                + STR_REQUESTCODE2
                , mtConfirmation, [mbYes, mbCancel], 0) = mrYes
                then begin
                    StrBody := 'Name: ' + TRegistration(rAOwner).RegName + #13#10
                        + 'E-mail: ' + TRegistration(rAOwner).RegEmail + #13#10
                        + 'Registration Number: ' + Copy(TRegistration(rAOwner).RegNumber, 1, 6) + #13#10
                        + TRegistration(rAOwner).TextAppName + ' ' + GetFileVersionStr(Application.ExeName) + #13#10;
                    StrBody := StringReplace(StrBody, '&&', '&', [rfReplaceAll]);
                    StrBody := URLEncode(StrBody , False);
                    Email := 'mailto:' + TRegistration(rAOwner).VerCodeUpdateEmailAddress + '?subject=' + URLEncode(StringReplace(TRegistration(rAOwner).TextAppName, '&&', '&', [rfReplaceAll]), False) + ' - Request Version Code';
                    Email := Email + '&body=' + StrBody;

                    Clipboard.SetTextBuf(PChar(StrBody));

                    ShellExecute(Handle,'open', PChar(Email), nil, nil, SW_SHOWNORMAL);
                end;
    except
        //*
    end;
end;

procedure TFormReg.ButtonRegisterClick(Sender: TObject);
var
  OkRegStr: String;
  ErrorRegStr: String;
  InvalidVersionCodeStr: String;
  ShowDialog, Success, ValidVersionCode, ValidRegistrationNumber: Boolean;
begin
    SetNewRegData;

    DoNotCloseRegistrationWindow := False;

    OkRegStr := STR_THANKYOU1 + (#13#10) + STR_THANKYOU2 + (#13#10) + STR_THANKYOU3;
    OkRegStr := StringReplace(OkRegStr, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
    OkRegStr := StringReplace(OkRegStr, '%USERNAME%', TRegistration(rAOwner).RegName, [rfReplaceAll]);
    OkRegStr := StringReplace(OkRegStr, '%PRODUCTID%', TRegistration(rAOwner).TextProductID, [rfReplaceAll]);
    OkRegStr := StringReplace(OkRegStr, '&&', '&', [rfReplaceAll]);

    ErrorRegStr := STR_ERROR_REG1 + (#13#10) + STR_ERROR_REG2;
    ErrorRegStr := StringReplace(ErrorRegStr, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
    ErrorRegStr := StringReplace(ErrorRegStr, '%USERNAME%', TRegistration(rAOwner).RegName, [rfReplaceAll]);
    ErrorRegStr := StringReplace(ErrorRegStr, '%PRODUCTID%', TRegistration(rAOwner).TextProductID, [rfReplaceAll]);
    ErrorRegStr := StringReplace(ErrorRegStr, '&&', '&', [rfReplaceAll]);

    InvalidVersionCodeStr := STR_ERROR_VERCODE1 + (#13#10) + STR_ERROR_VERCODE2;

    Success := TRegistration(rAOwner).Registered;
    ShowDialog := True;

    ValidRegistrationNumber := TRegistration(rAOwner).CheckRegistrationNumber(EditName.Text, EditEMail.Text, EditRegNum.Text , TRegistration(rAOwner).RandomSeedReg);
    //* Check version code
    ValidVersionCode := TRegistration(rAOwner).CheckVersionCode(EditRegNum.Text, EditVerCode.Text, TRegistration(rAOwner).RandomSeedVer);

    if ValidRegistrationNumber AND (NOT ValidVersionCode) then begin
        if MessageDlg(InvalidVersionCodeStr, mtWarning, [mbOk, mbCancel], 0) = mrOk then begin
            DoNotCloseRegistrationWindow := True;
        end;
        TRegistration(rAOwner).Save;
        Exit;
    end;

    if Success then begin
        if Assigned(TRegistration(rAOwner).OnDoRegistrationClick)
            then TRegistration(rAOwner).OnDoRegistrationClick(Sender, Success, ShowDialog);
        if ShowDialog
            then MessageDlg(OkRegStr, mtInformation, [mbOk], 0);
       	//Close;
    end else begin
        if Assigned(TRegistration(rAOwner).OnDoRegistrationClick)
            then TRegistration(rAOwner).OnDoRegistrationClick(Sender, Success, ShowDialog);
        if ShowDialog
            then MessageDlg(ErrorRegStr, mtWarning, [mbOk], 0);
    end;
    TRegistration(rAOwner).Save;
end;

procedure TFormReg.LabelOrderClick(Sender: TObject);
begin
    if Assigned(TRegistration(rAOwner).OnRegistrationClickOrder)
        then TRegistration(rAOwner).OnRegistrationClickOrder(Sender);
    ShellExecute(Handle,'open', PChar(TRegistration(rAOwner).URLOrderForm), nil, nil, SW_SHOWNORMAL);
end;

procedure TFormReg.LabelOrderMouseEnter(Sender: TObject);
begin
    (Sender as TLabel).Font.Color := clHighlight;
end;

procedure TFormReg.LabelOrderMouseLeave(Sender: TObject);
begin
    (Sender as TLabel).Font.Color := clWindowText;
end;

procedure TFormReg.FormActivate(Sender: TObject);
begin
    //MakeSolid(Sender);
end;

procedure TFormReg.FormDeactivate(Sender: TObject);
begin
    //MakeTransparent(Sender);
end;

procedure TFormReg.FormShow(Sender: TObject);
begin
    EditName.Text := TRegistration(rAOwner).RegName;
    EditEMail.Text := TRegistration(rAOwner).RegEMail;
    EditRegNum.Text := TRegistration(rAOwner).RegNumber;
    EditVerCode.Text := TRegistration(rAOwner).RegVerCode;
    EditNameChange(Sender);
    LabelOrder.Caption := StringReplace(STR_REG_ORDER, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
    LabelText1.Caption := StringReplace(STR_REG_TEXT1, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
    LabelText2.Caption := StringReplace(STR_REG_TEXT2, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
    LabelText2.Caption := StringReplace(LabelText2.Caption, '%PRICE%', TRegistration(rAOwner).TextPrice, [rfReplaceAll]);
    LabelText2.Caption := StringReplace(LabelText2.Caption, '%ORDERSITE%', TRegistration(rAOwner).TextOrderSite, [rfReplaceAll]);
    LabelText2.Caption := StringReplace(LabelText2.Caption, '%PRODUCTID%', TRegistration(rAOwner).TextProductID, [rfReplaceAll]);
    GroupBoxContainer.Caption := StringReplace(STR_GROUPBOX_CAPTION, '%PROGNAME%', TRegistration(rAOwner).TextAppName, [rfReplaceAll]);
end;

procedure TFormReg.EditEmailExit(Sender: TObject);
begin
    EditEmail.Text := Trim(EditEmail.Text);
end;

procedure TFormReg.EditNameChange(Sender: TObject);
begin
    if (EditName.Text <> '')
    AND (EditEMail.Text <> '')
    AND (EditRegNum.Text <> '')
    AND (EditVerCode.Text <> '')
    then begin
        //ButtonRegister.Enabled := True;
        ButtonRequest.Enabled := TRegistration(rAOwner).VerCodeUpdateEMailAddress <> '';
    end else begin
        //ButtonRegister.Enabled := False;
        ButtonRequest.Enabled := False;
    end;
end;

procedure TFormReg.EditNameExit(Sender: TObject);
begin
    EditName.Text := Trim(EditName.Text);
end;

procedure TFormReg.EditRegNumExit(Sender: TObject);
begin
    EditRegNum.Text := Trim(EditRegNum.Text);
end;

procedure TFormReg.EditVerCodeExit(Sender: TObject);
begin
    EditVerCode.Text := Trim(EditVerCode.Text);
end;

procedure TFormReg.ButtonOKClick(Sender: TObject);
begin
    ButtonRegisterClick(Sender);
    TRegistration(rAOwner).Save;
    if (NOT DoNotCloseRegistrationWindow)
    OR TRegistration(rAOwner).Registered
    then begin
        Close;
    end;
end;

procedure TFormReg.SetNewRegData;
begin
    TRegistration(rAOwner).RegName := EditName.Text;
    TRegistration(rAOwner).RegEMail := EditEMail.Text;
    TRegistration(rAOwner).RegNumber := EditRegNum.Text;
    TRegistration(rAOwner).RegVerCode := EditVerCode.Text;
end;

end.
